﻿Imports GrapeCity.ActiveReports.Design
Imports GrapeCity.ActiveReports.Design.Resources
Imports GrapeCity.ActiveReports
Imports System.Reflection
Imports System.Runtime.InteropServices

Imports System.IO

Public Class UnifiedDesignerForm

    <DllImport("user32.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Sub mouse_event(dwFlags As Long, dx As Long, dy As Long, cButtons As Long, dwExtraInfo As Long)
    End Sub


    Private Const MOUSEEVENTF_LEFTDOWN As Integer = &H2
    Private Const MOUSEEVENTF_LEFTUP As Integer = &H4
    Private Const MOUSEEVENTF_RIGHTDOWN As Integer = &H8
    Private Const MOUSEEVENTF_RIGHTUP As Integer = &H10

    Public Sub DoMouseClick()
        'Call the imported function with the cusrsor's current position
        Dim X As Integer = Cursor.Position.X
        Dim Y As Integer = Cursor.Position.Y
        mouse_event(MOUSEEVENTF_LEFTDOWN Or MOUSEEVENTF_LEFTUP, X, Y, 0, 0)
    End Sub

    Private Sub UnifiedDesignerForm_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        AddHandler reportdesigner.ContextMenuOpen, AddressOf ContextMenuOpen
    End Sub

    Private Sub ContextMenuOpen(sender As Object, e As ContextMenuOpenArgs)
        e.Cancel = True
    End Sub

    Private Sub UnifiedDesignerForm_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

    End Sub

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        'Populating the ToolBox,reportExplorer and Propertygrid
        Me.reportdesigner.Toolbox = Me.reporttoolbox 'Attaches the toolbox to the report designer
        Me.reportExplorer.ReportDesigner = Me.reportdesigner 'Attaches the report explorer to the report designer
        Me.reportdesigner.PropertyGrid = Me.reportpropertyGrid 'Attaches the Property Grid to the report designer
        'Populating the Menu
        Dim toolstrip As ToolStrip = Me.reportdesigner.CreateToolStrips(New DesignerToolStrips() {DesignerToolStrips.Menu})(0)
        Dim filemenu As ToolStripDropDownItem = DirectCast(toolstrip.Items(0), ToolStripDropDownItem)
        Me.CreateFileMenu(filemenu)
        Me.AppendToolStrips(0, New ToolStrip() {toolstrip})
        Me.AppendToolStrips(1, Me.reportdesigner.CreateToolStrips(New DesignerToolStrips() {DesignerToolStrips.Edit, DesignerToolStrips.Undo, DesignerToolStrips.Zoom}))
        Dim item As ToolStrip = Me.CreateReportToolbar()
        Me.AppendToolStrips(2, Me.reportdesigner.CreateToolStrips(New DesignerToolStrips() {DesignerToolStrips.Format, DesignerToolStrips.Layout}))

    End Sub
    'Adding DropDownItems to the ToolStripDropDownItem
    Private Sub CreateFileMenu(ByVal fileMenu As ToolStripDropDownItem)
        fileMenu.DropDownItems.Clear()
        fileMenu.DropDownItems.Add(New ToolStripMenuItem("New", Images.CmdNewReport, New EventHandler(AddressOf OnNew), DirectCast(131150, Keys)))
        fileMenu.DropDownItems.Add(New ToolStripMenuItem("Open", Images.CmdOpen, New EventHandler(AddressOf OnOpen), DirectCast(131151, Keys)))
        fileMenu.DropDownItems.Add(New ToolStripMenuItem("Export", Nothing, New EventHandler(AddressOf OnExport), DirectCast(131152, Keys)))

        fileMenu.DropDownItems.Add(New ToolStripMenuItem("Save", Images.CmdSave, New EventHandler(AddressOf OnSave), DirectCast(131155, Keys)))
        fileMenu.DropDownItems.Add(New ToolStripMenuItem("Save As", Images.CmdSaveAs, New EventHandler(AddressOf OnSaveAs)))
        fileMenu.DropDownItems.Add(New ToolStripSeparator())
        fileMenu.DropDownItems.Add(New ToolStripButton("Exit", Nothing, New EventHandler(AddressOf OnExit)))

    End Sub
    'Getting the Designer to open a new Report on Menu Item "New" click
    Private Sub OnNew(sender As Object, e As EventArgs)
        If Me.ConfirmSaveChanges() Then
            Me.reportdesigner.ExecuteAction(DesignerAction.NewReport)
        End If
    End Sub
    'Getting the Designer to open a Report on Menu Item "Open" click
    Private Sub OnOpen(sender As Object, e As EventArgs)
        If Me.ConfirmSaveChanges() Then
            Me.reportdesigner.ExecuteAction(DesignerAction.FileOpen)
        End If
    End Sub
    'Getting the Designer to Save the Report on Menu Item "Save" click
    Private Sub OnSave(sender As Object, e As EventArgs)
        Me.reportdesigner.ExecuteAction(DesignerAction.FileSave)
    End Sub
    'Getting the Designer to Save the Report on Menu Item "Save As" click
    Private Sub OnSaveAs(sender As Object, e As EventArgs)
        Me.reportdesigner.ExecuteAction(DesignerAction.FileSave)

    End Sub
    Private Sub OnExit(sender As Object, e As EventArgs)
        MyBase.Close()
    End Sub

    'Checking whether modifications have been made to the report loaded to the designer
    Private Function ConfirmSaveChanges() As Boolean
        If Me.reportdesigner.IsDirty Then
            Dim dialogresult__1 As DialogResult = MessageBox.Show("Report has been changed!!Do you wish to save it?", "", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
            If dialogresult__1 = DialogResult.Cancel Then
                Return False
            ElseIf dialogresult__1 = DialogResult.Yes Then
                Using _savedialog As New SaveFileDialog()
                    _savedialog.Filter = "rdlx files|*.rdlx"
                    _savedialog.DefaultExt = ".rdlx"


                    _savedialog.InitialDirectory = New DirectoryInfo(Application.ExecutablePath).Parent.Parent.Parent.FullName
                    If _savedialog.ShowDialog() = DialogResult.OK Then

                        Me.reportdesigner.SaveReport(New System.IO.FileInfo(_savedialog.FileName))
                        Me.reportdesigner.IsDirty = False
                    End If
                End Using

            End If
        End If

        Return True

    End Function
    Private Sub AppendToolStrips(row As Integer, toolStrips As IList(Of ToolStrip))
        Dim topToolStripPanel As ToolStripPanel = Me.ToolStripContainer1.TopToolStripPanel
        Dim num As Integer = toolStrips.Count
        While System.Threading.Interlocked.Decrement(num) >= 0
            topToolStripPanel.Join(toolStrips(num), row)
        End While
    End Sub
    Private Function CreateReportToolbar() As ToolStrip
        Return New ToolStrip(New ToolStripButton() {UnifiedDesignerForm.CreateToolStripButton("New", Images.CmdNewReport, New EventHandler(AddressOf OnNew), "New"), UnifiedDesignerForm.CreateToolStripButton("Open", Images.CmdOpen, New EventHandler(AddressOf OnOpen), "Open"), UnifiedDesignerForm.CreateToolStripButton("Save", Images.CmdSave, New EventHandler(AddressOf OnSave), "Save")})
    End Function
    Private Shared Function CreateToolStripButton(text As String, image As Image, handler As EventHandler, toolTip As String) As ToolStripButton
        Return New ToolStripButton(text, image, handler) With { _
         .DisplayStyle = ToolStripItemDisplayStyle.Image, _
            .ToolTipText = toolTip, _
         .DoubleClickEnabled = True _
        }
    End Function
    Private Sub OnExport(sender As Object, e As EventArgs)

           Try
                Dim _report As New GrapeCity.ActiveReports.SectionReport()
                _report = DirectCast(Me.reportdesigner.Report, GrapeCity.ActiveReports.SectionReport)
                _report.Run()
                Dim _export As New ExportProperties(_report.Document)
                _export.Show()
            Catch
                MessageBox.Show("There was an error in processing the report.Please redesign the same.")
            End Try
       

    End Sub

    Private rETree As New TreeView()
    Private Sub reportExplorer_Load(sender As System.Object, e As System.EventArgs) Handles reportExplorer.Load
        rETree = DirectCast(reportExplorer.Controls(0).Controls(0), TreeView)
        rETree.HideSelection = False
        AddHandler rETree.KeyDown, AddressOf rETree_KeyDown
        AddHandler rETree.NodeMouseClick, AddressOf rETree_NodeMouseClick
    End Sub
    Private Sub rETree_KeyDown(sender As Object, e As KeyEventArgs)
        If e.KeyCode = Keys.Delete Then
            MessageBox.Show("You are not allowed to delete it")
        End If
    End Sub

    Private Sub rETree_NodeMouseClick(sender As Object, e As TreeNodeMouseClickEventArgs)
        If e.Button = System.Windows.Forms.MouseButtons.Right Then
            If e.Node.Level >= 0 Then
                Dim p As Point = Cursor.Position
                Dim screenwidth As Integer = Screen.PrimaryScreen.Bounds.Width
                Dim leftWidth As Integer = screenwidth - p.X
                If leftWidth < 210 Then
                    p.Y -= 5
                Else
                    p.X -= 10
                End If
                Cursor.Position = p
                DoMouseClick()
                If leftWidth < 210 Then
                    p.Y += 5
                Else
                    p.X += 10
                End If
                Cursor.Position = p
                DoMouseClick()

            End If
        End If
    End Sub
End Class

